diff --git a/gcc/gcc.c b/gcc/gcc.c
index 691623a..58f629b 100644
--- a/gcc/gcc.c
+++ b/gcc/gcc.c
@@ -1418,7 +1418,7 @@ init_spec (void)
   if (specs)
     return;			/* Already initialized.  */
 
-  if (verbose_flag)
+  if (GCC_OPTION (verbose_flag))
     fnotice (stderr, "Using built-in specs.\n");
 
 #ifdef EXTRA_SPECS
@@ -1615,7 +1615,7 @@ set_spec (const char *name, const char *spec, bool user_p)
 		     : xstrdup (spec));
 
 #ifdef DEBUG_SPECS
-  if (verbose_flag)
+  if (GCC_OPTION (verbose_flag))
     fnotice (stderr, "Setting spec %s to '%s'\n\n", name, *(sl->ptr_spec));
 #endif
 
@@ -1724,7 +1724,7 @@ load_specs (const char *filename)
   char *specs;
   char *specs_p;
 
-  if (verbose_flag)
+  if (GCC_OPTION (verbose_flag))
     fnotice (stderr, "Reading specs from %s\n", filename);
 
   /* Open and stat the file.  */
@@ -1849,7 +1849,7 @@ read_specs (const char *filename, bool main_p, bool user_p)
 	      new_filename = find_a_file (&startfile_prefixes, p1, R_OK, true);
 	      if (new_filename)
 		read_specs (new_filename, false, user_p);
-	      else if (verbose_flag)
+	      else if (GCC_OPTION (verbose_flag))
 		fnotice (stderr, "could not find specs file %s\n", p1);
 	      continue;
 	    }
@@ -1917,7 +1917,7 @@ read_specs (const char *filename, bool main_p, bool user_p)
 			       "already defined spec %qs",
 		    filename, p1, p2);
 
-	      if (verbose_flag)
+	      if (GCC_OPTION (verbose_flag))
 		{
 		  fnotice (stderr, "rename spec %s to %s\n", p1, p2);
 #ifdef DEBUG_SPECS
@@ -2120,7 +2120,7 @@ delete_if_ordinary (const char *name)
 
   if (i == 'y' || i == 'Y')
 #endif /* DEBUG */
-  DELETE_IF_ORDINARY (name, st, verbose_flag);
+  DELETE_IF_ORDINARY (name, st, GCC_OPTION (verbose_flag));
 }
 
 static void
@@ -2353,7 +2353,7 @@ add_to_obstack (char *path, void *data)
 static void
 xputenv (const char *string)
 {
-  if (verbose_flag)
+  if (GCC_OPTION (verbose_flag))
     fnotice (stderr, "%s\n", string);
   putenv (CONST_CAST (char *, string));
 }
@@ -2607,13 +2607,13 @@ execute (void)
 
   gcc_assert (!processing_spec_function);
 
-  if (wrapper_string)
+  if (GCC_OPTION (wrapper_string))
     {
       string = find_a_file (&exec_prefixes,
 			    argbuf[0], X_OK, false);
       if (string)
 	argbuf[0] = string;
-      insert_wrapper (wrapper_string);
+      insert_wrapper (GCC_OPTION (wrapper_string));
     }
 
   /* Count # of piped commands.  */
@@ -2633,7 +2633,7 @@ execute (void)
   commands[0].prog = argbuf[0]; /* first command.  */
   commands[0].argv = argbuf.address ();
 
-  if (!wrapper_string)
+  if (!GCC_OPTION (wrapper_string))
     {
       string = find_a_file (&exec_prefixes, commands[0].prog, X_OK, false);
       commands[0].argv[0] = (string) ? string : commands[0].argv[0];
@@ -2659,7 +2659,7 @@ execute (void)
 
   /* If -v, print what we are about to do, and maybe query.  */
 
-  if (verbose_flag)
+  if (GCC_OPTION (verbose_flag))
     {
       /* For help listings, put a blank line between sub-processes.  */
       if (print_help_list)
@@ -2762,7 +2762,7 @@ execute (void)
 
   /* Run each piped subprocess.  */
 
-  pex = pex_init (PEX_USE_PIPES | ((report_times || report_times_to_file)
+  pex = pex_init (PEX_USE_PIPES | ((GCC_OPTION (report_times) || report_times_to_file)
 				   ? PEX_RECORD_TIMES : 0),
 		  progname, temp_filename);
   if (pex == NULL)
@@ -2807,7 +2807,7 @@ execute (void)
     if (!pex_get_status (pex, n_commands, statuses))
       fatal_error ("failed to get exit status: %m");
 
-    if (report_times || report_times_to_file)
+    if (GCC_OPTION (report_times) || report_times_to_file)
       {
 	times = (struct pex_time *) alloca (n_commands * sizeof (struct pex_time));
 	if (!pex_get_times (pex, n_commands, times))
@@ -2848,7 +2848,7 @@ execute (void)
 	    ret_code = -1;
 	  }
 
-	if (report_times || report_times_to_file)
+	if (GCC_OPTION (report_times) || report_times_to_file)
 	  {
 	    struct pex_time *pt = &times[i];
 	    double ut, st;
@@ -2860,7 +2860,7 @@ execute (void)
 
 	    if (ut + st != 0)
 	      {
-		if (report_times)
+		if (GCC_OPTION (report_times))
 		  fnotice (stderr, "# %s %.2f %.2f\n",
 			   commands[i].prog, ut, st);
 
@@ -3072,7 +3072,7 @@ display_help (void)
   fputs (_("  --target-help            Display target specific command line options\n"), stdout);
   fputs (_("  --help={common|optimizers|params|target|warnings|[^]{joined|separate|undocumented}}[,...]\n"), stdout);
   fputs (_("                           Display specific types of command line options\n"), stdout);
-  if (! verbose_flag)
+  if (! GCC_OPTION (verbose_flag))
     fputs (_("  (Use '-v --help' to display command line options of sub-processes)\n"), stdout);
   fputs (_("  --version                Display compiler version information\n"), stdout);
   fputs (_("  -dumpspecs               Display all of the built in spec strings\n"), stdout);
@@ -3379,7 +3379,7 @@ driver_handle_option (struct gcc_options *opts,
       break;
 
     case OPT_print_libgcc_file_name:
-      print_file_name = "libgcc.a";
+      GCC_OPTION (print_file_name) = "libgcc.a";
       do_save = false;
       break;
 
@@ -3582,7 +3582,7 @@ driver_handle_option (struct gcc_options *opts,
 	 is intended for use in shell scripts to capture the
 	 driver-generated command line.  */
       verbose_only_flag++;
-      verbose_flag = 1;
+      GCC_OPTION (verbose_flag) = 1;
       do_save = false;
       break;
 
@@ -3652,7 +3652,7 @@ driver_handle_option (struct gcc_options *opts,
       break;
 
     case OPT_fwpa:
-      flag_wpa = "";
+      GCC_OPTION (flag_wpa) = "";
       break;
 
     default:
@@ -3992,12 +3992,12 @@ process_command (unsigned int decoded_options_count,
       save_temps_prefix = NULL;
     }
 
-  if (save_temps_flag && use_pipes)
+  if (save_temps_flag && GCC_OPTION (use_pipes))
     {
       /* -save-temps overrides -pipe, so that temp files are produced */
       if (save_temps_flag)
 	warning (0, "-pipe ignored because -save-temps specified");
-      use_pipes = 0;
+      GCC_OPTION (use_pipes) = 0;
     }
 
   if (!compare_debug)
@@ -4629,7 +4629,7 @@ do_spec_1 (const char *spec, int inswitch, const char *soft_matched_part)
 	    /* A `|' before the newline means use a pipe here,
 	       but only if -pipe was specified.
 	       Otherwise, execute now and don't pass the `|' as an arg.  */
-	    if (use_pipes)
+	    if (GCC_OPTION (use_pipes))
 	      {
 		input_from_pipe = 1;
 		break;
@@ -4783,7 +4783,7 @@ do_spec_1 (const char *spec, int inswitch, const char *soft_matched_part)
 	    }
 	    goto create_temp_file;
 	  case '|':
-	    if (use_pipes)
+	    if (GCC_OPTION (use_pipes))
 	      {
 		obstack_1grow (&obstack, '-');
 		delete_this_arg = 0;
@@ -4799,7 +4799,7 @@ do_spec_1 (const char *spec, int inswitch, const char *soft_matched_part)
 	      }
 	    goto create_temp_file;
 	  case 'm':
-	    if (use_pipes)
+	    if (GCC_OPTION (use_pipes))
 	      {
 		/* consume suffix */
 		while (*p == '.' || ISALNUM ((unsigned char) *p))
@@ -6504,7 +6504,7 @@ main (int argc, char **argv)
 
   /* Process sysroot_suffix_spec.  */
   if (*sysroot_suffix_spec != 0
-      && !no_sysroot_suffix
+      && !GCC_OPTION (no_sysroot_suffix)
       && do_spec_2 (sysroot_suffix_spec) == 0)
     {
       if (argbuf.length () > 1)
@@ -6528,7 +6528,7 @@ main (int argc, char **argv)
 
   /* Process sysroot_hdrs_suffix_spec.  */
   if (*sysroot_hdrs_suffix_spec != 0
-      && !no_sysroot_suffix
+      && !GCC_OPTION (no_sysroot_suffix)
       && do_spec_2 (sysroot_hdrs_suffix_spec) == 0)
     {
       if (argbuf.length () > 1)
@@ -6703,7 +6703,7 @@ main (int argc, char **argv)
 
   /* Obey some of the options.  */
 
-  if (print_search_dirs)
+  if (GCC_OPTION (print_search_dirs))
     {
       printf (_("install: %s%s\n"),
 	      gcc_exec_prefix ? gcc_exec_prefix : standard_exec_prefix,
@@ -6715,15 +6715,15 @@ main (int argc, char **argv)
       return (0);
     }
 
-  if (print_file_name)
+  if (GCC_OPTION (print_file_name))
     {
-      printf ("%s\n", find_file (print_file_name));
+      printf ("%s\n", find_file (GCC_OPTION (print_file_name)));
       return (0);
     }
 
-  if (print_prog_name)
+  if (GCC_OPTION (print_prog_name))
     {
-      if (use_ld != NULL && ! strcmp (print_prog_name, "ld"))
+      if (use_ld != NULL && ! strcmp (GCC_OPTION (print_prog_name), "ld"))
 	{
 	  /* Append USE_LD to to the default linker.  */
 #ifdef DEFAULT_LINKER
@@ -6753,20 +6753,20 @@ main (int argc, char **argv)
 	      return (0);
 	    }
 #endif
-	  print_prog_name = concat (print_prog_name, use_ld, NULL);
+	  GCC_OPTION (print_prog_name) = concat (GCC_OPTION (print_prog_name), use_ld, NULL);
 	}
-      char *newname = find_a_file (&exec_prefixes, print_prog_name, X_OK, 0);
-      printf ("%s\n", (newname ? newname : print_prog_name));
+      char *newname = find_a_file (&exec_prefixes, GCC_OPTION (print_prog_name), X_OK, 0);
+      printf ("%s\n", (newname ? newname : GCC_OPTION (print_prog_name)));
       return (0);
     }
 
-  if (print_multi_lib)
+  if (GCC_OPTION (print_multi_lib))
     {
       print_multilib_info ();
       return (0);
     }
 
-  if (print_multi_directory)
+  if (GCC_OPTION (print_multi_directory))
     {
       if (multilib_dir == NULL)
 	printf (".\n");
@@ -6775,7 +6775,7 @@ main (int argc, char **argv)
       return (0);
     }
 
-  if (print_multiarch)
+  if (GCC_OPTION (print_multiarch))
     {
       if (multiarch_dir == NULL)
 	printf ("\n");
@@ -6784,7 +6784,7 @@ main (int argc, char **argv)
       return (0);
     }
 
-  if (print_sysroot)
+  if (GCC_OPTION (print_sysroot))
     {
       if (target_system_root)
 	{
@@ -6796,7 +6796,7 @@ main (int argc, char **argv)
       return (0);
     }
 
-  if (print_multi_os_directory)
+  if (GCC_OPTION (print_multi_os_directory))
     {
       if (multilib_os_dir == NULL)
 	printf (".\n");
@@ -6805,7 +6805,7 @@ main (int argc, char **argv)
       return (0);
     }
 
-  if (print_sysroot_headers_suffix)
+  if (GCC_OPTION (print_sysroot_headers_suffix))
     {
       if (*sysroot_hdrs_suffix_spec)
 	{
@@ -6824,7 +6824,7 @@ main (int argc, char **argv)
     {
       display_help ();
 
-      if (! verbose_flag)
+      if (! GCC_OPTION (verbose_flag))
 	{
 	  printf (_("\nFor bug reporting instructions, please see:\n"));
 	  printf ("%s.\n", bug_report_url);
@@ -6849,7 +6849,7 @@ main (int argc, char **argv)
       fputs (_("This is free software; see the source for copying conditions.  There is NO\n\
 warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\n\n"),
 	     stdout);
-      if (! verbose_flag)
+      if (! GCC_OPTION (verbose_flag))
 	return 0;
 
       /* We do not exit here. We use the same mechanism of --help to print
@@ -6858,7 +6858,7 @@ warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\n\n"
       fflush (stdout);
     }
 
-  if (verbose_flag)
+  if (GCC_OPTION (verbose_flag))
     {
       int n;
       const char *thrmod;
@@ -6916,7 +6916,7 @@ warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\n\n"
 
   explicit_link_files = XCNEWVEC (char, n_infiles);
 
-  combine_inputs = have_o || flag_wpa;
+  combine_inputs = have_o || GCC_OPTION (flag_wpa);
 
   for (i = 0; (int) i < n_infiles; i++)
     {
@@ -7000,7 +7000,7 @@ warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\n\n"
 		this_file_error = 1;
 	      else if (compare_debug && debug_check_temp_file[0])
 		{
-		  if (verbose_flag)
+		  if (GCC_OPTION (verbose_flag))
 		    inform (0, "recompiling with -fcompare-debug");
 
 		  compare_debug = -compare_debug;
@@ -7025,7 +7025,7 @@ warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\n\n"
 			      && filename_cmp (debug_check_temp_file[0],
 					       debug_check_temp_file[1]));
 
-		  if (verbose_flag)
+		  if (GCC_OPTION (verbose_flag))
 		    inform (0, "comparing final insns dumps");
 
 		  if (compare_files (debug_check_temp_file))
@@ -7182,7 +7182,7 @@ warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\n\n"
 
  out:
   return (signal_count != 0 ? 2
-	  : seen_error () ? (pass_exit_codes ? greatest_status : 1)
+	  : seen_error () ? (GCC_OPTION (pass_exit_codes) ? greatest_status : 1)
 	  : 0);
 }
 
@@ -8159,13 +8159,13 @@ sanitize_spec_function (int argc, const char **argv)
     return NULL;
 
   if (strcmp (argv[0], "address") == 0)
-    return (flag_sanitize & SANITIZE_ADDRESS) ? "" : NULL;
+    return (GCC_OPTION (flag_sanitize) & SANITIZE_ADDRESS) ? "" : NULL;
   if (strcmp (argv[0], "thread") == 0)
-    return (flag_sanitize & SANITIZE_THREAD) ? "" : NULL;
+    return (GCC_OPTION (flag_sanitize) & SANITIZE_THREAD) ? "" : NULL;
   if (strcmp (argv[0], "undefined") == 0)
-    return (flag_sanitize & SANITIZE_UNDEFINED) ? "" : NULL;
+    return (GCC_OPTION (flag_sanitize) & SANITIZE_UNDEFINED) ? "" : NULL;
   if (strcmp (argv[0], "leak") == 0)
-    return ((flag_sanitize
+    return ((GCC_OPTION (flag_sanitize)
 	     & (SANITIZE_ADDRESS | SANITIZE_LEAK | SANITIZE_THREAD))
 	    == SANITIZE_LEAK) ? "" : NULL;
   return NULL;
diff --git a/gcc/gcse.c b/gcc/gcse.c
index 2bb0b5f..edcd74a 100644
--- a/gcc/gcse.c
+++ b/gcc/gcse.c
@@ -916,7 +916,7 @@ oprs_unchanged_p (const_rtx x, const_rtx insn, int avail_p)
       }
 
     case MEM:
-      if (! flag_gcse_lm
+      if (! GCC_OPTION (flag_gcse_lm)
 	  || load_killed_in_block_p (current_bb, DF_INSN_LUID (insn),
 				     x, avail_p))
 	return 0;
@@ -1304,7 +1304,7 @@ hash_scan_set (rtx set, rtx insn, struct hash_table_d *table)
   /* In case of store we want to consider the memory value as available in
      the REG stored in that memory. This makes it possible to remove
      redundant loads from due to stores to the same location.  */
-  else if (flag_gcse_las && REG_P (src) && MEM_P (dest))
+  else if (GCC_OPTION (flag_gcse_las) && REG_P (src) && MEM_P (dest))
       {
         unsigned int regno = REGNO (src);
 	int max_distance = 0;
@@ -1500,7 +1500,7 @@ record_last_mem_set_info (rtx insn)
 {
   int bb;
 
-  if (! flag_gcse_lm)
+  if (! GCC_OPTION (flag_gcse_lm))
     return;
 
   /* load_killed_in_block_p will handle the case of calls clobbering
@@ -2679,11 +2679,11 @@ one_pre_gcse_pass (void)
 
   alloc_hash_table (&expr_hash_table);
   add_noreturn_fake_exit_edges ();
-  if (flag_gcse_lm)
+  if (GCC_OPTION (flag_gcse_lm))
     compute_ld_motion_mems ();
 
   compute_hash_table (&expr_hash_table);
-  if (flag_gcse_lm)
+  if (GCC_OPTION (flag_gcse_lm))
     trim_ld_motion_mems ();
   if (dump_file)
     dump_hash_table (dump_file, "Expression", &expr_hash_table);
@@ -2698,7 +2698,7 @@ one_pre_gcse_pass (void)
       free_pre_mem ();
     }
 
-  if (flag_gcse_lm)
+  if (GCC_OPTION (flag_gcse_lm))
     free_ld_motion_mems ();
   remove_fake_exit_edges ();
   free_hash_table (&expr_hash_table);
@@ -2987,7 +2987,7 @@ should_hoist_expr_to_dom (basic_block expr_bb, struct expr *expr,
   int visited_allocated_locally = 0;
   int decreased_pressure = 0;
 
-  if (flag_ira_hoist_pressure)
+  if (GCC_OPTION (flag_ira_hoist_pressure))
     {
       /* Record old information of basic block BB when it is visited
 	 at the first time.  */
@@ -3003,7 +3003,7 @@ should_hoist_expr_to_dom (basic_block expr_bb, struct expr *expr,
      is exhausted.  */
   if (distance > 0)
     {
-      if (flag_ira_hoist_pressure)
+      if (GCC_OPTION (flag_ira_hoist_pressure))
 	{
 	  /* Prefer to hoist EXPR if register pressure is decreased.  */
 	  if (decreased_pressure > *nregs)
@@ -3068,7 +3068,7 @@ should_hoist_expr_to_dom (basic_block expr_bb, struct expr *expr,
     {
       /* If EXPR can be hoisted to expr_bb, record basic blocks through
 	 which EXPR is hoisted in hoisted_bbs.  */
-      if (flag_ira_hoist_pressure && !pred)
+      if (GCC_OPTION (flag_ira_hoist_pressure) && !pred)
 	{
 	  /* Record the basic block from which EXPR is hoisted.  */
 	  bitmap_set_bit (visited, bb->index);
@@ -3194,7 +3194,7 @@ hoist_code (void)
 		  == ENTRY_BLOCK_PTR_FOR_FN (cfun)->next_bb));
 
   from_bbs = BITMAP_ALLOC (NULL);
-  if (flag_ira_hoist_pressure)
+  if (GCC_OPTION (flag_ira_hoist_pressure))
     hoisted_bbs = BITMAP_ALLOC (NULL);
 
   dom_tree_walk = get_all_dominated_blocks (CDI_DOMINATORS,
@@ -3331,7 +3331,7 @@ hoist_code (void)
 		/* Punt, no point hoisting a single occurrence.  */
 		occrs_to_hoist.release ();
 
-	      if (flag_ira_hoist_pressure
+	      if (GCC_OPTION (flag_ira_hoist_pressure)
 		  && !occrs_to_hoist.is_empty ())
 		{
 		  /* Increase register pressure of basic blocks to which
@@ -3345,7 +3345,7 @@ hoist_code (void)
 		      data->max_reg_pressure[pressure_class] += nregs;
 		    }
 		}
-	      else if (flag_ira_hoist_pressure)
+	      else if (GCC_OPTION (flag_ira_hoist_pressure))
 		{
 		  /* Restore register pressure and live_in info for basic
 		     blocks recorded in hoisted_bbs when expr will not be
@@ -3359,7 +3359,7 @@ hoist_code (void)
 		    }
 		}
 
-	      if (flag_ira_hoist_pressure)
+	      if (GCC_OPTION (flag_ira_hoist_pressure))
 		bitmap_clear (hoisted_bbs);
 
 	      insn_inserted_p = 0;
@@ -3411,7 +3411,7 @@ hoist_code (void)
 
   dom_tree_walk.release ();
   BITMAP_FREE (from_bbs);
-  if (flag_ira_hoist_pressure)
+  if (GCC_OPTION (flag_ira_hoist_pressure))
     BITMAP_FREE (hoisted_bbs);
 
   free (bb_size);
@@ -3603,7 +3603,7 @@ one_code_hoisting_pass (void)
   doing_code_hoisting_p = true;
 
   /* Calculate register pressure for each basic block.  */
-  if (flag_ira_hoist_pressure)
+  if (GCC_OPTION (flag_ira_hoist_pressure))
     {
       regstat_init_n_sets_and_refs ();
       ira_set_pseudo_classes (false, dump_file);
@@ -3633,7 +3633,7 @@ one_code_hoisting_pass (void)
       free_code_hoist_mem ();
     }
 
-  if (flag_ira_hoist_pressure)
+  if (GCC_OPTION (flag_ira_hoist_pressure))
     {
       free_aux_for_blocks ();
       free_reg_info ();
@@ -3832,7 +3832,7 @@ simple_mem (const_rtx x)
   if (reg_mentioned_p (stack_pointer_rtx, x))
     return 0;
 
-  if (flag_float_store && FLOAT_MODE_P (GET_MODE (x)))
+  if (GCC_OPTION (flag_float_store) && FLOAT_MODE_P (GET_MODE (x)))
     return 0;
 
   return 1;
@@ -4112,7 +4112,7 @@ is_too_expensive (const char *pass)
 static bool
 gate_rtl_pre (void)
 {
-  return optimize > 0 && flag_gcse
+  return GCC_OPTION (optimize) > 0 && GCC_OPTION (flag_gcse)
     && !cfun->calls_setjmp
     && optimize_function_for_speed_p (cfun)
     && dbg_cnt (pre);
@@ -4134,7 +4134,7 @@ execute_rtl_pre (void)
 static bool
 gate_rtl_hoist (void)
 {
-  return optimize > 0 && flag_gcse
+  return GCC_OPTION (optimize) > 0 && GCC_OPTION (flag_gcse)
     && !cfun->calls_setjmp
     /* It does not make sense to run code hoisting unless we are optimizing
        for code size -- it rarely makes programs faster, and can make then
diff --git a/gcc/ggc-page.c b/gcc/ggc-page.c
index ccc87ea..55b71c5 100644
--- a/gcc/ggc-page.c
+++ b/gcc/ggc-page.c
@@ -2055,7 +2055,7 @@ ggc_collect (void)
     return;
 
   timevar_push (TV_GC);
-  if (!quiet_flag)
+  if (!GCC_OPTION (quiet_flag))
     fprintf (stderr, " {GC %luk -> ", (unsigned long) G.allocated / 1024);
   if (GGC_DEBUG_LEVEL >= 2)
     fprintf (G.debug_file, "BEGIN COLLECTING\n");
@@ -2089,7 +2089,7 @@ ggc_collect (void)
 
   timevar_pop (TV_GC);
 
-  if (!quiet_flag)
+  if (!GCC_OPTION (quiet_flag))
     fprintf (stderr, "%luk}", (unsigned long) G.allocated / 1024);
   if (GGC_DEBUG_LEVEL >= 2)
     fprintf (G.debug_file, "END COLLECTING\n");
diff --git a/gcc/gimple-fold.c b/gcc/gimple-fold.c
index 267c1fd..4657aba 100644
--- a/gcc/gimple-fold.c
+++ b/gcc/gimple-fold.c
@@ -106,7 +106,7 @@ can_refer_decl_in_current_unit_p (tree decl, tree from_decl)
   if (!from_decl
       || TREE_CODE (from_decl) != VAR_DECL
       || !DECL_EXTERNAL (from_decl)
-      || (flag_ltrans
+      || (GCC_OPTION (flag_ltrans)
 	  && symtab_get_node (from_decl)->in_other_partition))
     return true;
   /* We are folding reference from external vtable.  The vtable may reffer
@@ -133,7 +133,7 @@ can_refer_decl_in_current_unit_p (tree decl, tree from_decl)
      units where they are used and when the other unit was compiled with LTO
      it is possible that vtable was kept public while the function itself
      was privatized. */
-  if (!flag_ltrans && (!DECL_COMDAT (decl) || !cgraph_function_flags_ready))
+  if (!GCC_OPTION (flag_ltrans) && (!DECL_COMDAT (decl) || !cgraph_function_flags_ready))
     return true;
 
   /* OK we are seeing either COMDAT or static variable.  In this case we must
@@ -381,7 +381,7 @@ fold_gimple_assign (gimple_stmt_iterator *si)
 	    tree val = OBJ_TYPE_REF_EXPR (rhs);
 	    if (is_gimple_min_invariant (val))
 	      return val;
-	    else if (flag_devirtualize && virtual_method_call_p (val))
+	    else if (GCC_OPTION (flag_devirtualize) && virtual_method_call_p (val))
 	      {
 		bool final;
 		vec <cgraph_node *>targets
@@ -1119,7 +1119,7 @@ gimple_fold_call (gimple_stmt_iterator *gsi, bool inplace)
 	  gimple_call_set_fn (stmt, OBJ_TYPE_REF_EXPR (callee));
 	  changed = true;
 	}
-      else if (flag_devirtualize && !inplace && virtual_method_call_p (callee))
+      else if (GCC_OPTION (flag_devirtualize) && !inplace && virtual_method_call_p (callee))
 	{
 	  bool final;
 	  vec <cgraph_node *>targets
@@ -3212,7 +3212,7 @@ gimple_get_virt_method_for_vtable (HOST_WIDE_INT token,
   if (TREE_CODE (v) != VAR_DECL
       || !DECL_VIRTUAL_P (v))
     {
-      gcc_assert (in_lto_p);
+      gcc_assert (GCC_OPTION (in_lto_p));
       /* Pass down that we lost track of the target.  */
       if (can_refer)
 	*can_refer = false;
@@ -3228,7 +3228,7 @@ gimple_get_virt_method_for_vtable (HOST_WIDE_INT token,
   gcc_assert (init);
   if (init == error_mark_node)
     {
-      gcc_assert (in_lto_p);
+      gcc_assert (GCC_OPTION (in_lto_p));
       /* Pass down that we lost track of the target.  */
       if (can_refer)
 	*can_refer = false;
diff --git a/gcc/gimple-low.c b/gcc/gimple-low.c
index 80fd786..2eb1cd9 100644
--- a/gcc/gimple-low.c
+++ b/gcc/gimple-low.c
@@ -337,7 +337,7 @@ lower_stmt (gimple_stmt_iterator *gsi, struct lower_data *data)
 		return;
 	      }
 	    else if (DECL_FUNCTION_CODE (decl) == BUILT_IN_POSIX_MEMALIGN
-		     && flag_tree_bit_ccp)
+		     && GCC_OPTION (flag_tree_bit_ccp))
 	      {
 		lower_builtin_posix_memalign (gsi);
 		return;
@@ -650,7 +650,7 @@ lower_gimple_return (gimple_stmt_iterator *gsi, struct lower_data *data)
   /* Generate a goto statement and remove the return statement.  */
  found:
   /* When not optimizing, make sure user returns are preserved.  */
-  if (!optimize && gimple_has_location (stmt))
+  if (!GCC_OPTION (optimize) && gimple_has_location (stmt))
     DECL_ARTIFICIAL (tmp_rs.label) = 0;
   t = gimple_build_goto (tmp_rs.label);
   gimple_set_location (t, gimple_location (stmt));
diff --git a/gcc/gimple-ssa-isolate-paths.c b/gcc/gimple-ssa-isolate-paths.c
index 56fcfc8..d133aef 100644
--- a/gcc/gimple-ssa-isolate-paths.c
+++ b/gcc/gimple-ssa-isolate-paths.c
@@ -276,8 +276,8 @@ find_implicit_erroneous_behaviour (void)
 		    continue;
 
 		  if (infer_nonnull_range (use_stmt, lhs,
-					   flag_isolate_erroneous_paths_dereference,
-					   flag_isolate_erroneous_paths_attribute))
+					   GCC_OPTION (flag_isolate_erroneous_paths_dereference),
+					   GCC_OPTION (flag_isolate_erroneous_paths_attribute)))
 
 		    {
 		      duplicate = isolate_path (bb, duplicate,
@@ -329,8 +329,8 @@ find_explicit_erroneous_behaviour (void)
 	     to detect explicit NULL pointer dereferences and other uses
 	     where a non-NULL value is required.  */
 	  if (infer_nonnull_range (stmt, null_pointer_node,
-				   flag_isolate_erroneous_paths_dereference,
-				   flag_isolate_erroneous_paths_attribute))
+				   GCC_OPTION (flag_isolate_erroneous_paths_dereference),
+				   GCC_OPTION (flag_isolate_erroneous_paths_attribute)))
 	    {
 	      insert_trap_and_remove_trailing_statements (&si,
 							  null_pointer_node);
@@ -419,8 +419,8 @@ gate_isolate_erroneous_paths (void)
 {
   /* If we do not have a suitable builtin function for the trap statement,
      then do not perform the optimization.  */
-  return (flag_isolate_erroneous_paths_dereference != 0
-	  || flag_isolate_erroneous_paths_attribute != 0);
+  return (GCC_OPTION (flag_isolate_erroneous_paths_dereference) != 0
+	  || GCC_OPTION (flag_isolate_erroneous_paths_attribute) != 0);
 }
 
 namespace {
diff --git a/gcc/gimple-ssa-strength-reduction.c b/gcc/gimple-ssa-strength-reduction.c
index 9320b51..1c160aa 100644
--- a/gcc/gimple-ssa-strength-reduction.c
+++ b/gcc/gimple-ssa-strength-reduction.c
@@ -568,7 +568,7 @@ find_basis_for_candidate (slsr_cand_t c)
 	}
     }
 
-  if (flag_expensive_optimizations && !basis && c->kind == CAND_REF)
+  if (GCC_OPTION (flag_expensive_optimizations) && !basis && c->kind == CAND_REF)
     {
       tree alt_base_expr = get_alternative_base (c->base_expr);
       if (alt_base_expr)
@@ -653,7 +653,7 @@ alloc_cand_and_find_basis (enum cand_kind kind, gimple gs, tree base,
     c->basis = find_basis_for_candidate (c);
 
   record_potential_basis (c, base);
-  if (flag_expensive_optimizations && kind == CAND_REF)
+  if (GCC_OPTION (flag_expensive_optimizations) && kind == CAND_REF)
     {
       tree alt_base = get_alternative_base (base);
       if (alt_base)
@@ -3649,7 +3649,7 @@ execute_strength_reduction (void)
 static bool
 gate_strength_reduction (void)
 {
-  return flag_tree_slsr;
+  return GCC_OPTION (flag_tree_slsr);
 }
 
 namespace {
diff --git a/gcc/gimple.c b/gcc/gimple.c
index e9851ca..9a6686a 100644
--- a/gcc/gimple.c
+++ b/gcc/gimple.c
@@ -2532,7 +2532,7 @@ infer_nonnull_range (gimple stmt, tree op, bool dereference, bool attribute)
 {
   /* We can only assume that a pointer dereference will yield
      non-NULL if -fdelete-null-pointer-checks is enabled.  */
-  if (!flag_delete_null_pointer_checks
+  if (!GCC_OPTION (flag_delete_null_pointer_checks)
       || !POINTER_TYPE_P (TREE_TYPE (op))
       || gimple_code (stmt) == GIMPLE_ASM)
     return false;
diff --git a/gcc/gimplify.c b/gcc/gimplify.c
index ad2178d..7138c23 100644
--- a/gcc/gimplify.c
+++ b/gcc/gimplify.c
@@ -475,7 +475,7 @@ lookup_tmp_var (tree val, bool is_formal)
      block, which means it will go into memory, causing much extra
      work in reload and final and poorer code generation, outweighing
      the extra memory allocation here.  */
-  if (!optimize || !is_formal || TREE_SIDE_EFFECTS (val))
+  if (!GCC_OPTION (optimize) || !is_formal || TREE_SIDE_EFFECTS (val))
     ret = create_tmp_from_val (val, is_formal);
   else
     {
@@ -1104,7 +1104,7 @@ gimplify_bind_expr (tree *expr_p, gimple_seq *pre_p)
 	  /* Only care for variables that have to be in memory.  Others
 	     will be rewritten into SSA names, hence moved to the top-level.  */
 	  && !is_gimple_reg (t)
-	  && flag_stack_reuse != SR_NONE)
+	  && GCC_OPTION (flag_stack_reuse) != SR_NONE)
 	{
 	  tree clobber = build_constructor (TREE_TYPE (t),
 					    NULL);
@@ -1337,7 +1337,7 @@ gimplify_decl_expr (tree *stmt_p, gimple_seq *seq_p)
 
       if (TREE_CODE (DECL_SIZE_UNIT (decl)) != INTEGER_CST
 	  || (!TREE_STATIC (decl)
-	      && flag_stack_check == GENERIC_STACK_CHECK
+	      && GCC_OPTION (flag_stack_check) == GENERIC_STACK_CHECK
 	      && compare_tree_int (DECL_SIZE_UNIT (decl),
 				   STACK_CHECK_MAX_VAR_SIZE) > 0))
 	gimplify_vla_decl (decl, seq_p);
@@ -3015,7 +3015,7 @@ gimplify_cond_expr (tree *expr_p, gimple_seq *pre_p, fallback_t fallback)
       /* For -O0 avoid this optimization if the COND_EXPR and GOTO_EXPR
 	 have different locations, otherwise we end up with incorrect
 	 location information on the branches.  */
-      && (optimize
+      && (GCC_OPTION (optimize)
 	  || !EXPR_HAS_LOCATION (expr)
 	  || !EXPR_HAS_LOCATION (TREE_OPERAND (expr, 1))
 	  || EXPR_LOCATION (expr) == EXPR_LOCATION (TREE_OPERAND (expr, 1))))
@@ -3033,7 +3033,7 @@ gimplify_cond_expr (tree *expr_p, gimple_seq *pre_p, fallback_t fallback)
       /* For -O0 avoid this optimization if the COND_EXPR and GOTO_EXPR
 	 have different locations, otherwise we end up with incorrect
 	 location information on the branches.  */
-      && (optimize
+      && (GCC_OPTION (optimize)
 	  || !EXPR_HAS_LOCATION (expr)
 	  || !EXPR_HAS_LOCATION (TREE_OPERAND (expr, 2))
 	  || EXPR_LOCATION (expr) == EXPR_LOCATION (TREE_OPERAND (expr, 2))))
@@ -3722,7 +3722,7 @@ gimplify_init_constructor (tree *expr_p, gimple_seq *pre_p, gimple_seq *post_p,
 	    && num_nonzero_elements > 1
 	    && TREE_READONLY (object)
 	    && TREE_CODE (object) == VAR_DECL
-	    && (flag_merge_constants >= 2 || !TREE_ADDRESSABLE (object)))
+	    && (GCC_OPTION (flag_merge_constants) >= 2 || !TREE_ADDRESSABLE (object)))
 	  {
 	    if (notify_temp_creation)
 	      return GS_ERROR;
@@ -5308,7 +5308,7 @@ gimplify_target_expr (tree *expr_p, gimple_seq *pre_p, gimple_seq *post_p)
 	 gimplify_bind_expr.  */
       if (gimplify_ctxp->in_cleanup_point_expr
 	  && needs_to_live_in_memory (temp)
-	  && flag_stack_reuse == SR_ALL)
+	  && GCC_OPTION (flag_stack_reuse) == SR_ALL)
 	{
 	  tree clobber = build_constructor (TREE_TYPE (temp),
 					    NULL);
@@ -8537,7 +8537,7 @@ gimplify_body (tree fndecl, bool do_parms)
   gcc_assert (gimplify_ctxp == NULL);
   push_gimplify_context ();
 
-  if (flag_openmp)
+  if (GCC_OPTION (flag_openmp))
     {
       gcc_assert (gimplify_omp_ctxp == NULL);
       if (lookup_attribute ("omp declare target", DECL_ATTRIBUTES (fndecl)))
@@ -8621,7 +8621,7 @@ gimplify_body (tree fndecl, bool do_parms)
       nonlocal_vlas = NULL;
     }
 
-  if ((flag_openmp || flag_openmp_simd) && gimplify_omp_ctxp)
+  if ((GCC_OPTION (flag_openmp) || GCC_OPTION (flag_openmp_simd)) && gimplify_omp_ctxp)
     {
       delete_omp_context (gimplify_omp_ctxp);
       gimplify_omp_ctxp = NULL;
@@ -8650,7 +8650,7 @@ flag_instrument_functions_exclude_p (tree fndecl)
 {
   vec<char_p> *v;
 
-  v = (vec<char_p> *) flag_instrument_functions_exclude_functions;
+  v = (vec<char_p> *) GCC_OPTION (flag_instrument_functions_exclude_functions);
   if (v && v->length () > 0)
     {
       const char *name;
@@ -8663,7 +8663,7 @@ flag_instrument_functions_exclude_p (tree fndecl)
 	  return true;
     }
 
-  v = (vec<char_p> *) flag_instrument_functions_exclude_files;
+  v = (vec<char_p> *) GCC_OPTION (flag_instrument_functions_exclude_files);
   if (v && v->length () > 0)
     {
       const char *name;
@@ -8729,7 +8729,7 @@ gimplify_function_tree (tree fndecl)
      the entry hook and wrap the whole function in a TRY_FINALLY_EXPR to
      catch the exit hook.  */
   /* ??? Add some way to ignore exceptions for this TFE.  */
-  if (flag_instrument_function_entry_exit
+  if (GCC_OPTION (flag_instrument_function_entry_exit)
       && !DECL_NO_INSTRUMENT_FUNCTION_ENTRY_EXIT (fndecl)
       && !flag_instrument_functions_exclude_p (fndecl))
     {
diff --git a/gcc/go/go-backend.c b/gcc/go/go-backend.c
index de33601..78cc1a4 100644
--- a/gcc/go/go-backend.c
+++ b/gcc/go/go-backend.c
@@ -89,7 +89,7 @@ go_trampoline_info (unsigned int *size, unsigned int *alignment)
 void
 go_imported_unsafe (void)
 {
-  flag_strict_aliasing = false;
+  GCC_OPTION (flag_strict_aliasing) = false;
 
   /* Let the backend know that the options have changed.  */
   targetm.override_options_after_change ();
